from random import sample

def erzeuge_kandidaten(n):
    '''Gibt [1, 2, 3, ..., n] zufällig gemischt zurück.'''
    return sample(range(1, n+1), n)

def bester_nach_test(liste, r):
    '''Gibt besten Kandiaten bei r Testkandidaten zurück.'''
    test_max = max(liste[:r])
    for wert in liste[r:]: 
        if wert > test_max: # ist jemand besser?
            return wert     # wenn ja, gibt seinen Wert zurück
    return liste[-1]        # ... sonst den Wert des letzten

def simulation(n, r, w):
    '''Gibt Anteil der optimalen Wahl bei w Wiederholungen zurück.'''
    erfolge = 0
    best = n
    for i in range(0, w):
        liste = erzeuge_kandidaten(n)
        wahl = bester_nach_test(liste, r)
        if wahl == best:
            erfolge += 1 
    return erfolge/w # relative Häufigkeit
    
# Wiederhole die Simulation w-Mal für jedes r und schreibe
# r und die zugehörige Erfolgsquote in eine CSV-Datei.
dd = open('partnerwahl.csv', mode='w')
dd.write('r;q\n')
n, w = 100, 5000  # Anzahl Kandidaten & Wiederholungen
for r in range(1, n):
    erfolgsquote = simulation(n, r, w)
    print(r, erfolgsquote)
    dd.write('{0};{1}\n'.format(r, erfolgsquote))
dd.close()
    
    







    
    
    
